--[[
	FixSound by JaedxRapture of the Ace Site Forums
	origin: http://www.wowace.com/forums/index.php?topic=8779.20
]]

local _G = _G
local pairs = _G.pairs

local musicQueue = {}
local soundQueue = {}
local soundFileQueue = {}

local playMusic = _G.PlayMusic
_G.PlayMusic = function(file)
	musicQueue[file] = true
end

local playSound = _G.PlaySound
_G.PlaySound = function(file)
	soundQueue[file] = true
end

local playSoundFile = _G.PlaySoundFile
_G.PlaySoundFile = function(file)
	soundFileQueue[file] = true
end

local soundFrame = _G.CreateFrame("Frame")
soundFrame:SetScript("OnUpdate",function()
	for file in pairs(musicQueue) do
		playMusic(file)
		musicQueue[file] = nil
	end
	for file in pairs(soundQueue) do
		playSound(file)
		soundQueue[file] = nil
	end
	for file in pairs(soundFileQueue) do
		playSoundFile(file)
		soundFileQueue[file] = nil
	end
end)
